// ==ANONUserScript==
// @file        anon_messagesctrl.js
// @name        Anon Messages Control
// @description Anon Messages COntrol Functions
// @author      SolarAngel (SA) <furry[you know what comes here]tesla.rcub.bg.ac.yu>
// ==/ANONUserScript==

// Messages Control Object
var FGMessages = {
  // compact
  compact: function(d,id){
    try{
      var o = d.getElementById(id);
      if(o=='undefined') throw(' [Object Error] ID = "'+id+'" not found in element collection.');
      o.style.display = ((o.style.display=='none')?'block':'none')
    }catch(e){ alert(e); }
  },
  // colapse
  colapse: function(d, msgType){
    var divs = d.getElementsByTagName('div');
    for(var i=0; i<divs.length; i++){
      var div = divs[i];
      var divMsgType = div.getAttribute('msgType');
      if(divMsgType!=null){
        if (msgType == -2) div.style.display = 'none';
        else if (divMsgType==msgType) div.style.display = 'none';
      };
    };
  },
  // check
  check:   function(d, msgType, checked){
    try {
      var checks = d.getElementsByTagName('input');
      var search = (msgType>0)?'check'+msgType:'check';
      var searchCH  = (msgType>0)?'menuCH'+msgType:'menuCH';
      if (checks && checks.length){
        for (var i=0; i<checks.length; i++){
          if(checks[i].id.indexOf(search)  !=-1) checks[i].checked = checked;
          if(checks[i].id.indexOf(searchCH)!=-1) checks[i].checked = checked;
        }
      };
    }catch(e){ alert(e); };
  },


  //*********************************************************************************************
  //*********************************************************************************************
  //
  // FAST REPLY // AJAX MESSAGING
  //
  //*********************************************************************************************
  //*********************************************************************************************

  //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ FGMessages.getHashProperty
  // getHashProperty
  getHashProperty: function(url,hashname){
    var p=url.indexOf(hashname);
    if(p!=-1){
      var pe = url.indexOf('&',p);
      if(pe>p) return url.substring((p+hashname.length+1), pe);
      else     return url.substring((p+hashname.length+1));
    }
    return null;
  },

  //--------------------------------------------------------------------------------------------
  //
  // QUOTE SYSTEM
  //
  quoteSystem:
  {
    trimMulti    : function(exp)
    {
      if (exp == null)
      	return exp;
      return exp.replace(/^[ \n]*|[ \n]*$/g,'');
    },
    splitAt72    : function(text)
    {
      if(text.length>72){
        var ps = text.indexOf(' ', 72);
        if(ps>=72) text = text.substring(0,ps)+'\n'+this.splitAt72(text.substring(ps+1));
      };
      return text;
    },    
    quoteSimple  : function(name, text)
    {
      name = this.trimMulti(name);
      text = this.filter(text, true);
      var sz = text.split('\n');
      for (var i=0; i<sz.length; i++) sz[i] = this.splitAt72(sz[i]);
      text = sz.join('\n');
      if (name.lastIndexOf(':')!=name.length-1) name +=':'; // [SA] fix double '::' on circ reply
      return (name+'\n| '+text.replace(/\n/g,'\n| ')+'\n\n');
    },    
    quote        : function(name, text)
    {
      name = this.trimMulti(name);
      text = this.filter(text, true);
      return ('[quote='+name+']'+text+'[/quote]\n'); // add one new line for user to enter text at
    },
    filter       : function(text, compress)
    {
      text = text.replace(/[\x20]{1,}/igm,' ');           // compress spacing '  ' -> ' '
      text = text.replace(/[\x0b\r\n]{2,}/igm,'\n\n');    // compress lines to double
      if (compress) text = text.replace(/[\n]+/igm,'\n'); // compress double lines to single
      return this.trimMulti(text);
    },
  },

  //--------------------------------------------------------------------------------------------
  //
  // ON FAST REPLY
  //
  onFastReply: function(document, IID_REPLY, quoteType) {

    try {     
      var divReply    = document.getElementById(IID_REPLY);
      var msgURL      = divReply.getAttribute('msgURL')    ||'___messageziel=0___';
      var msgTo       = divReply.getAttribute('msgTo')     ||' [::]';
      var msgSubject  = 'Re:'+(divReply.getAttribute('msgSubject')||'No Subject');
      var msgText     = divReply.getAttribute('msgText')   ||'';
      var msgSig     =  divReply.getAttribute('msgSig')    ||'';
      var PIN         = parseInt(msgURL.replace(/.*messageziel\=(\d+).*/igm,'$1'));
      if (PIN==0){
        alert('Can\'t send message to your self!\n PIN='+PIN);
        return;
      }
      msgTo = msgTo.substring(0,msgTo.indexOf('[')-1);
      switch(quoteType||0){      
          case 1 : msgText = this.quoteSystem.quote(msgTo, msgText); break;          
          case 2 : msgText = this.quoteSystem.quoteSimple(msgTo, msgText); break;
          default: msgText = "";
      };
	  msgText = msgText + "\n" + msgSig;
      if (divReply.childNodes.length==0  || divReply.getAttribute('quoteType') > 3) { // on first initialization
        divReply.setAttribute('quoteType',0);
        divReply.innerHTML = ''
         + '<input type="hidden" id="gesendet" value="1">\n'
         + '<table width="100%" cellspacing=1 cellpadding=1><tr><td>&nbsp;'+fg_LOCAL.PMMsg+'</td><td align=right>[<a href="javascript:FGMessages.onFastReply(document,\''+IID_REPLY+'\',0);" title="'+fg_LOCAL.Clean+'"><b >'+fg_LOCAL.Clean+'</b></a>] [<a href="javascript:FGMessages.onFastReply(document,\''+IID_REPLY+'\',2);" title="'+fg_LOCAL.Quote+'"><b >'+fg_LOCAL.Quote+'</b></a>] [<a href="javascript:FGMessages.onFastReply(document,\''+IID_REPLY+'\',1);" title="'+fg_LOCAL.EQuote+'"><b >'+fg_LOCAL.EQuote+'</b></a>] [<a href="javascript:FGMessages.onFastReply(document,\''+IID_REPLY+'\',10);"><b>'+fg_LOCAL.Close+'</b></a>]</td></tr>\n'
         + '<tr><th>'+fg_LOCAL.Recipient+'</th><th>'+ msgTo +'</th></tr>\n'
         + '<tr><th>'+fg_LOCAL.Subject+'</th><th><input type="text" id="betreff" maxlength="40" size="40" style="width:75%" value="'+ msgSubject +'" /></th></tr>\n'
  	     + '<tr><th ><span id="cntChars'+IID_REPLY+'_TEXT">0</span><hr/>2000</th><th><textarea id="'+IID_REPLY+'_TEXT" cols="40" rows="10" size="100" onkeyup="javascript:cntchar2(2000,\''+IID_REPLY+'_TEXT\')">'+msgText+'</textarea></th></tr>\n'
         + '<tr><th>PIN:'+PIN+'<th><input type="submit" value="'+fg_LOCAL.Send+'" onclick="FGMessages.SendPrivate(this, \''+IID_REPLY+'\'); return false;"/></th></tr></table>\n';
        document.getElementById(IID_REPLY+"_TEXT").value = msgText;
        divReply.style.display = 'block';
        cntchar2(2000,IID_REPLY+"_TEXT");
      } // end if on first initialization
      else if (divReply.getAttribute('quoteType')!=quoteType && quoteType != 10) {
        divReply.setAttribute('quoteType',quoteType);
        document.getElementById(IID_REPLY+"_TEXT").value = msgText;      
        cntchar2(2000,IID_REPLY+"_TEXT");
        divReply.style.display = 'block';
      } else if (divReply.getAttribute('quoteType') == quoteType || quoteType == 10){
      	if (divReply.style.display == 'block')
      		divReply.style.display = 'none';
      	else
      		divReply.style.display = 'block';     
      };
      document.msgWrite = (divReply.style.display=='block')?true:document.undef;
    }catch(e){ alert(e); };
  },
  //--------------------------------------------------------------------------------------------
  //
  // ON FAST CIRC REPLY
  //
  onFastCircReply: function(document, IID_REPLY, quoteType) {
    try {
      var divReply    = document.getElementById(IID_REPLY);
      var msgTo       = divReply.getAttribute('msgTo') ||' [::]';
      var msgSubject  = divReply.getAttribute('msgSubject') ||'Re: No Subject';
      var msgText     = divReply.getAttribute('msgText') || '';
	  var msgSig     =  divReply.getAttribute('msgSig') ||'';
	  
	  msgTo = msgTo.substring(0,msgTo.indexOf('[')-1);	
      switch(quoteType||4){
          case  5: msgText = this.quoteSystem.quote(msgTo, msgText); break;
          case  6: msgText = this.quoteSystem.quoteSimple(msgTo, msgText); break;
          default: msgText = "";
      }
      msgText = msgText + "\n" + msgSig;
	
      if (divReply.childNodes.length==0 || divReply.getAttribute('quoteType') < 4 ) { // on first initialization
        divReply.setAttribute('quoteType',4);
        divReply.innerHTML = ''
           + '<input type="hidden" id="r" value="0">\n'
           + '<table width="100%" cellspacing=1 cellpadding=1><tr><td>&nbsp;<nobr>'+fg_LOCAL.CircMsg+'</nobr></td><td width=100% align=right>[<a href="javascript:FGMessages.onFastCircReply(document,\''+IID_REPLY+'\',4);" title="'+fg_LOCAL.Clean+'"><b>'+fg_LOCAL.Clean+'</b></a>] [<a href="javascript:FGMessages.onFastCircReply(document,\''+IID_REPLY+'\',6);" title="'+fg_LOCAL.Quote+'"><b>'+fg_LOCAL.Quote+'</b></a>] [<a href="javascript:FGMessages.onFastCircReply(document,\''+IID_REPLY+'\',5);" title="'+fg_LOCAL.EQuote+'"><b>'+fg_LOCAL.EQuote+'</b></a>] [<a href="javascript:FGMessages.onFastCircReply(document,\''+IID_REPLY+'\',10);">'+fg_LOCAL.Close+'</a>]</td></tr>\n'           
  	     + '<tr><th ><span id="cntChars'+IID_REPLY+'_TEXT">0</span><hr/>2000</th><th><textarea id="'+IID_REPLY+'_TEXT" cols="40" rows="10" size="100" onkeyup="javascript:cntchar2(2000,\''+IID_REPLY+'_TEXT\')">'+msgText+'</textarea></th></tr>\n'
           + '<tr><th colspan="2"><input type="submit" value="'+fg_LOCAL.Send+'" onclick="FGMessages.SendCircular(this, \''+IID_REPLY+'\'); return false;"/></th></tr></table>\n';
        document.getElementById(IID_REPLY+"_TEXT").value = msgText;                      
        divReply.style.display = 'block';              
        cntchar2(2000,IID_REPLY+'_TEXT');        
      } // end if on first initialization
      else if (divReply.getAttribute('quoteType') != quoteType && quoteType != 10){
        divReply.setAttribute('quoteType',quoteType);
        document.getElementById(IID_REPLY+"_TEXT").value = msgText;        
        cntchar2(2000,IID_REPLY+"_TEXT"); 
        divReply.style.display = 'block';
      } else if (divReply.getAttribute('quoteType') == quoteType || quoteType == 10){
      	if (divReply.style.display == 'block')
      		divReply.style.display = 'none';
      	else
      		divReply.style.display = 'block';     
      };
      document.msgWrite = (divReply.style.display=='block')?true:document.undef;
    }catch(e){ alert(e); };
  },

  //--------------------------------------------------------------------------------------------
  //
  // AJAX Support For Sending messages - (Language independent)
  //

  // clearResponse
  clearResponse: function(htmlResponse){
    htmlResponse = (htmlResponse||'-ERROR-');
    htmlResponse = unescape(htmlResponse.toString());
    var tagStart = "id='content'>";
    var tagEnd   = "end content area"
    // </div>
    // <!-- END CONTENT AREA -->
    var ps = htmlResponse.toLowerCase().indexOf(tagStart);
    if(ps>-1) htmlResponse = htmlResponse.substring(ps+tagStart.length+2);
    var pe = htmlResponse.toLowerCase().indexOf(tagEnd);
    if(pe>-1) htmlResponse = htmlResponse.substring(0,pe-13);
    return htmlResponse;
  },

  // ON PRIVATE RESPONSE
  onPrivateResponse: function(container, HTML) {
    try {
      //**********************************************
      // NOTICE: this is AJAXConstructor object
      //**********************************************

      // parse text out only
      var sent = false;
      var page = document.createElement('div');
          page.innerHTML = this.clearResponse(HTML);
      var font = page.getElementsByTagName('font');
      if(font.length) sent = (font[0].color.toLowerCase()=='#00ff00');  // probably RGB
      if (sent){
        container.style.display = 'none';
        container.innerHTML = "";
      }else
        alert(fg_LOCAL.Error);
    }catch(e){ alert(e); };
  },

  // ON CIRCULAR RESPONSE
  onCircularResponse: function(container, HTML) {
    try {
      var sent = false;
      var page = document.createElement('div');
          page.innerHTML = this.clearResponse(HTML);;
      var input = page.getElementsByTagName('input');
      for(var i=0; i<input.length; i++) if(input[i].value.toLowerCase()=='ok'){ sent=true; break; };
      if(sent){
        container.style.display = 'none';
        container.innerHTML = "";
      }else
        alert(fg_LOCAL.Error);
    }catch(e){ alert(e); };
  },

  // SEND PRIVATE
  SendPrivate: function(button,id) {
    try {
    	this.Send(button,id,'msgURL',function(){ FGMessages.onPrivateResponse(this.container, this.response); })
    	button.setAttribute("disabled","true");
    	setTimeout(function () { button.removeAttribute("disabled");},1000);
    }catch(e){ alert(e); };
  },

  // SEND CIRCULAR
  SendCircular: function(button,id) {
    try {
      this.Send(button,id,'msgURLCirc',function(){ FGMessages.onCircularResponse(this.container, this.response); })
    	button.setAttribute("disabled","true");
    	setTimeout(function () { button.removeAttribute("disabled");},1000);      
    }catch(e){ alert(e); };
  },

  // CREATE AJAX OBJECT AND FILL WITH DATA
  Send: function(button, DIVID, attrib, FNRESPONSE){
    var ax        = new sack();
    var container = document.getElementById(DIVID);

    ax.container    = container;
    ax.encodeWithCSEnc = false;
    ax.execute      = true;
    ax.requestFile  = container.getAttribute(attrib, false);
    if(!ax.requestFile){
      alert('no url to send a message');
      return null;
    }

    ax.runResponse  = FNRESPONSE;
      
    var nodes = container.getElementsByTagName('input');
    for (var i=0; i<nodes.length; i++){
      var o = nodes[i];
      if(o.id)
        ax.setVar(o.id, (o.value) );  
    }
    
    var nodes = container.getElementsByTagName('textarea');
    if (nodes.length < 1)
    	return null;        
    ax.setVar("text", (nodes[0].value));
    ax.runAJAX(null, true);  // not async
    return ax;
  }
};

var texts = new Array();
function cntchar2(m, id) {  
  var text = document.getElementById(id);
  if (text.value.length > m) {
    text.value = texts[id];
  } else {
    texts[id] = text.value;
  }
  document.getElementById('cntChars'+id).childNodes[0].data = text.value.length;
}